### Virtual Method

# EDataServer OAuth2Service get_authentication_policy

since: 3.28

#### Declaration [src]

    EOAuth2ServiceNavigationPolicy
    get_authentication_policy (
      EOAuth2Service* service,
      ESource* source,
      const gchar* uri
    )

#### Description [src]

Used to decide what to do when the server redirects to the next page. The default implementation always returns `E_OAUTH2_SERVICE_NAVIGATION_POLICY_ALLOW`.

This method is called before `e_oauth2_service_extract_authorization_code()` and can be used to block certain resources or to abort the authentication when the server redirects to an unexpected page (like when user denies authorization in the page).

Available since: 3.28

#### Parameters

`source`

  Type: `ESource`

  An associated `ESource`.

  The data is owned by the caller of the method.

`uri`

  Type: `const gchar*`

  A URI of the navigation resource.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

#### Return value

Type: `EOAuth2ServiceNavigationPolicy`

One of `EOAuth2ServiceNavigationPolicy`.